package com.galaxis.manatee.capsule.dto;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/4/8 2:04 下午
 */
@Data
public class ChuanyunProjectDTO {

//    /**
//     * 主键
//     */
//    private String projectId;

//    /**
//     * 项目编号
//     */
//    private String projectCode;

    /**
     * 联合主键信息
     */
    private ChuanyunProjectPrimaryKey chuanyunProjectPrimaryKey;

    /**
     * 项目名称
     */
    private String projectName;

    /**
     * 项目类型git
     */
    private String projectTypeCode;

    /**
     * 下发组织机构编码
     */
    private String organizationCode;

    /**
     * 项目签约日期
     */
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime projectSignDateTime;

    /**
     * 客户ID
     */
    private String customerCode;

    /**
     * 应用场景
     * 多场景间用 ;隔开
     */
    private String scene;

    /**
     * 部门编号
     */
    private String department;

    /**
     * 项目经理(工号)
     */
    private String projectManager;

    /**
     * 项目所有人(工号)
     */
    private String projectOwner;

    /**
     * 计划开始时间
     */
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime planStartDate;

    /**
     * 计划结束时间
     */
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime planEndDate;

    /**
     * 默认支出类型编码
     */
    private String defaultExpenseCode;

    /**
     * 当前阶段编码
     */
    private String stage;

    /**
     * 业务来源
     */
    private String businessSource;

    /**
     * 业务类型
     */
    private String businessType;
}
