package com.galaxis.manatee.service.impl;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunImplCostDO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.service.ImplCostService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Service
public class ImplCostServiceImpl implements ImplCostService {

    private ChuanYunManager chuanYunManager;

    @Autowired
    public void setChuanYunManager(ChuanYunManager chuanYunManager) {
        this.chuanYunManager = chuanYunManager;
    }

    @Override
    public List<ChuanyunImplCostDO> findAllInChuanyun() {
        List<ChuanyunImplCostDO> implCostList = new ArrayList<>();
        ObjectMapper objectMapper = new ObjectMapper();
        int start = 0;
        long totalCount = 0L;
        boolean flag = true;
        int pageSize = 100;
        while (flag) {
            try {
                //从氚云查询数据
                var filter = Filter.instance(start, start + pageSize, true);
                var chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunImplCostDO.SCHEMA_CODE, filter);
                if (chuanyunFindAllResponse.getReturnData() == null || chuanyunFindAllResponse.getReturnData().getBizObjectArray() == null) {
                    flag = false;
                    continue;
                }
                if (chuanyunFindAllResponse.getReturnData().getTotalCount() >= start + pageSize) {
                    start += pageSize;
                } else {
                    flag = false;
                }
                //获取项目总数
                totalCount = chuanyunFindAllResponse.getReturnData().getTotalCount();
                //保存
                List<Object> bizObjectArray = chuanyunFindAllResponse.getReturnData().getBizObjectArray();
                List<ChuanyunImplCostDO> bpList = objectMapper.convertValue(bizObjectArray, new TypeReference<>() {
                });
                implCostList.addAll(bpList);
            } catch (Exception e) {
                log.error(e.getMessage());
                e.printStackTrace();
            }

        }
        return implCostList;
    }
}
